package command

import (
	"context"
	"fmt"
	"os"
	"os/signal"

	"github.com/qsfera/server/pkg/config/configlog"
	"github.com/qsfera/server/pkg/log"
	"github.com/qsfera/server/pkg/runner"
	"github.com/qsfera/server/pkg/tracing"
	"github.com/qsfera/server/services/antivirus/pkg/config"
	"github.com/qsfera/server/services/antivirus/pkg/config/parser"
	"github.com/qsfera/server/services/antivirus/pkg/server/debug"
	"github.com/qsfera/server/services/antivirus/pkg/service"
	"github.com/spf13/cobra"
)

// Server is the entrypoint for the server command.
func Server(cfg *config.Config) *cobra.Command {
	return &cobra.Command{
		Use:   "server",
		Short: fmt.Sprintf("start the %s service without runtime (unsupervised mode)", cfg.Service.Name),
		PreRunE: func(cmd *cobra.Command, args []string) error {
			return configlog.ReturnFatal(parser.ParseConfig(cfg))
		},
		RunE: func(cmd *cobra.Command, args []string) error {
			var cancel context.CancelFunc
			if cfg.Context == nil {
				cfg.Context, cancel = signal.NotifyContext(context.Background(), runner.StopSignals...)
				defer cancel()
			}
			ctx := cfg.Context
			logger := log.Configure(cfg.Service.Name, cfg.Commons, cfg.LogLevel)

			traceProvider, err := tracing.GetTraceProvider(cmd.Context(), cfg.Commons.TracesExporter, cfg.Service.Name)
			if err != nil {
				return err
			}

			gr := runner.NewGroup()
			{
				svc, err := service.NewAntivirus(cfg, logger, traceProvider)
				if err != nil {
					fmt.Errorf("failed to initialize antivirus service: %v", err)
					os.Exit(1)
				}

				gr.Add(runner.New(cfg.Service.Name+".svc", func() error {
					return svc.Run()
				}, func() {
					svc.Close()
				}))
			}

			{
				debugServer, err := debug.Server(
					debug.Logger(logger),
					debug.Context(ctx),
					debug.Config(cfg),
				)
				if err != nil {
					logger.Info().Err(err).Str("server", "debug").Msg("Failed to initialize server")
					return err
				}

				gr.Add(runner.NewGolangHttpServerRunner(cfg.Service.Name+".debug", debugServer))
			}

			grResults := gr.Run(ctx)

			// return the first non-nil error found in the results
			for _, grResult := range grResults {
				if grResult.RunnerError != nil {
					return grResult.RunnerError
				}
			}
			return nil
		},
	}
}
